/*
 * Copyright 2014 Red Hat, Inc.
 *
 * Red Hat licenses this file to you under the Apache License, version 2.0
 * (the "License"); you may not use this file except in compliance with the
 * License.  You may obtain a copy of the License at:
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

package io.vertx.reactivex.sqlclient;

import java.util.Map;
import io.reactivex.Observable;
import io.reactivex.Flowable;
import io.reactivex.Single;
import io.reactivex.Completable;
import io.reactivex.Maybe;
import java.util.List;

/**
 * A set of rows.
 *
 * <p/>
 * NOTE: This class has been automatically generated from the {@link io.vertx.sqlclient.RowSet original} non RX-ified interface using Vert.x codegen.
 */

@io.vertx.lang.rx.RxGen(io.vertx.sqlclient.RowSet.class)
public class RowSet extends io.vertx.reactivex.sqlclient.SqlResult<io.vertx.reactivex.sqlclient.RowSet> implements java.lang.Iterable<io.vertx.reactivex.sqlclient.Row> {

  @Override
  public String toString() {
    return delegate.toString();
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    RowSet that = (RowSet) o;
    return delegate.equals(that.delegate);
  }
  
  @Override
  public int hashCode() {
    return delegate.hashCode();
  }

  public static final io.vertx.lang.rx.TypeArg<RowSet> __TYPE_ARG = new io.vertx.lang.rx.TypeArg<>(    obj -> new RowSet((io.vertx.sqlclient.RowSet) obj),
    RowSet::getDelegate
  );

  private final io.vertx.sqlclient.RowSet delegate;
  
  public RowSet(io.vertx.sqlclient.RowSet delegate) {
    super(delegate);
    this.delegate = delegate;
  }

  public io.vertx.sqlclient.RowSet getDelegate() {
    return delegate;
  }

  /**
   * Get the result value.
   * @return the result
   */
  public io.vertx.reactivex.sqlclient.RowSet value() { 
    io.vertx.reactivex.sqlclient.RowSet ret = io.vertx.reactivex.sqlclient.RowSet.newInstance(delegate.value());
    return ret;
  }

  public io.vertx.reactivex.sqlclient.RowIterator iterator() { 
    io.vertx.reactivex.sqlclient.RowIterator ret = io.vertx.reactivex.sqlclient.RowIterator.newInstance(delegate.iterator());
    return ret;
  }

  public io.vertx.reactivex.sqlclient.RowSet next() { 
    io.vertx.reactivex.sqlclient.RowSet ret = io.vertx.reactivex.sqlclient.RowSet.newInstance(delegate.next());
    return ret;
  }


  public static  RowSet newInstance(io.vertx.sqlclient.RowSet arg) {
    return arg != null ? new RowSet(arg) : null;
  }
}
